/**********************************************************************
*
* IBM Confidential
*
* OCO Source Materials
*
* 5724-L66
*
* (c) Copyright IBM Corp.  2006 All Rights Reserved
*
* The source code for this program is not published or otherwise divested of its trade secrets,
* irrespective of what has been deposited with the U.S. Copyright Office.
* 
**/
/*
 * Created on Nov 21, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.datatools.mdsi.modeltransform;

import java.util.ArrayList;
import java.util.List;

/**
 * @author ellersr
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class NDMtoNDMOptions extends TransformerOptions {

	protected boolean splitTerms=false;
	protected List excludedTerms=null;
	protected boolean updateDescription=false;
	protected boolean ignoreCase=false;
	protected boolean flattenGlossaries=false;
	
	/**
	 * Use this ocnstructor for normal invocation of the (@link NDMtoNDM}
	 * API. The option should be set by calls to {@link #getInputFileNames},
	 * {@link #setOutputFileName(String)}, {@link #setSplitTerms(boolean)}, and
	 * {@link #getExcludedTerms()} prior to invoking the post encoder.
	 */
	public NDMtoNDMOptions() {
	}
	
	/**
	 * Use this constructor if the (@link NDMtoNDM} is being invoked from
	 * the command line (e.g. as part of a stand-alone test) and the
	 * options are passed in as a String array.
	 * @param args
	 */
	final static int EXCLUDED_OPTION=LAST_OPTION+1;
	final static int SPLIT_OPTION=LAST_OPTION+2;
	final static int UPDATE_DESCRIPTION_OPTION=LAST_OPTION+3;
	final static int FLATTEN_GLOSSARIES_OPTION=LAST_OPTION+4;
	

	
	protected int getOptionCode(String optionString) {
		int optionCode=UNKNOWN_OPTION;
		if (optionString.startsWith("-excluded")) {
			optionCode=EXCLUDED_OPTION;
		}
		else if (optionString.startsWith("-split")) {
			optionCode=SPLIT_OPTION;
			setSplitTerms(true);
		}
		else if (optionString.startsWith("-updateDescription")) {
			optionCode=UPDATE_DESCRIPTION_OPTION;
			setUpdateDescription(true);
		}
		else if (optionString.startsWith("-flattenGlossaries")) {
			optionCode=FLATTEN_GLOSSARIES_OPTION;
			setFlattenGlossaries(true);
		}
		else {
			optionCode=super.getOptionCode(optionString);
		}
		return optionCode;
	}
	
	protected void processOption(String optionString, int optionCode) {
		switch (optionCode) {
		case EXCLUDED_OPTION:
			getExcludedTerms().add(optionString);
			break;
		case SPLIT_OPTION:
			break;
		case UPDATE_DESCRIPTION_OPTION:
			break;
		case FLATTEN_GLOSSARIES_OPTION:
			break;
		default:
			super.processOption(optionString, optionCode);
			break;
		}
			
	}
	
	public NDMtoNDMOptions(String[] args) {
		super(args);
	}
	
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return super.toString() +", exclude temrs: "+getExcludedTerms().toString() +
		", split terms: "+isSplitTerms()+
		", update description: "+isUpdateDescription() +
		", flatten glossaries: "+isFlattenGlossaries();
	}
	/**
	 * @return Returns the splitTerms.
	 */
	public boolean isSplitTerms() {
		return splitTerms;
	}
	/**
	 * @param splitTerms The splitTerms to set.
	 */
	public void setSplitTerms(boolean splitTerms) {
		this.splitTerms = splitTerms;
	}
	/**
	 * Use this to get the list of excluded terms.
	 * <p>
	 * Note that in order to modify this list, you should 
	 * first invoke the getExcludedTerms method to access the list
	 * and then invoke the appropriate List method (e.g. add or addAll) to modify the list.
	 * @return Returns the excludedTerms.
	 */
	public List getExcludedTerms() {
		if (excludedTerms==null) {
			excludedTerms=new ArrayList();
		}
		return excludedTerms;
	}
	
	/**
	 * @return Returns the updateDescription.
	 */
	public boolean isUpdateDescription() {
		return updateDescription;
	}
	/**
	 * @param updateDescription The updateDescription to set.
	 */
	public void setUpdateDescription(boolean updateDescription) {
		this.updateDescription = updateDescription;
	}
	/**
	 * @return Returns the ignoreCase.
	 */
	public boolean isIgnoreCase() {
		return ignoreCase;
	}
	/**
	 * @param ignoreCase The ignoreCase to set.
	 */
	public void setIgnoreCase(boolean ignoreCase) {
		this.ignoreCase = ignoreCase;
	}
	/**
	 * @return Returns the flattenGlossaries.
	 */
	public boolean isFlattenGlossaries() {
		return flattenGlossaries;
	}
	/**
	 * @param flattenGlossaries The flattenGlossaries to set.
	 */
	public void setFlattenGlossaries(boolean flattenGlossaries) {
		this.flattenGlossaries = flattenGlossaries;
	}
}
