/**********************************************************************
*
* IBM Confidential
*
* OCO Source Materials
*
* 5724-L66
*
* (c) Copyright IBM Corp.  2006 All Rights Reserved
*
* The source code for this program is not published or otherwise divested of its trade secrets,
* irrespective of what has been deposited with the U.S. Copyright Office.
* 
**/
/*
 * Created on Nov 21, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.datatools.mdsi.modeltransform;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author ellersr
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TransformerOptions {

	protected List inputFileNames=null;
	protected String outputFileName;
	protected List inputStreams=null;
	protected OutputStream outputStream=null;
	
	/**
	 * Use this ocnstructor for normal invocation of the (@link NDMtoNDM}
	 * API. The option should be set by calls to {@link #getInputFileNames},
	 * {@link #setOutputFileName(String)}, {@link #setSplitTerms(boolean)}, and
	 * {@link #getExcludedTerms()} prior to invoking the post encoder.
	 */
	public TransformerOptions() {
	}
	
	/**
	 * Use this constructor if the (@link NDMtoNDM} is being invoked from
	 * the command line (e.g. as part of a stand-alone test) and the
	 * options are passed in as a String array.
	 * @param args
	 */
	final static int UNKNOWN_OPTION=0;
	final static int INPUT_OPTION=1;
	final static int OUTPUT_OPTION=2;
	final static int LAST_OPTION=OUTPUT_OPTION;
	
	protected int getOptionCode(String optionString) {
		int optionCode=UNKNOWN_OPTION;
		if (optionString.startsWith("-in")) {
			optionCode=INPUT_OPTION;
		}
		else if (optionString.startsWith("-out")) {
			optionCode=OUTPUT_OPTION;
		}
		return optionCode;
	}
	protected void processOption(String optionString, int option_code) {
		switch (option_code) {
		case INPUT_OPTION:
			getInputFileNames().add(optionString);
			break;
		case OUTPUT_OPTION:
			setOutputFileName(optionString);
			break;
        default:
        	break;
		}
			
	}
	public TransformerOptions(String[] args) {
		
		int option_code=UNKNOWN_OPTION;
		
		for (int a=0; a<args.length; a++){
			String nextArg = args[a];
			
			if (nextArg.startsWith("-")) {
				option_code = getOptionCode(nextArg);
			}
			else {
				processOption(nextArg, option_code);
			}
				
		}
	}
	
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "Input files: "+inputFileNames.toString() +", output files: "+outputFileName.toString();
	}
	/**
	 * Use this to get the list of input file names.
	 * <p>
	 * Note that in order to modify this list, you should 
	 * first invoke the getExcludedTerms method to access the list
	 * and then invoke the appropriate List method (e.g. add or addAll) to modify the list.
	 * @return Returns the excludedTerms.
	 */
	public List getInputFileNames() {
		if (inputFileNames==null) {
			inputFileNames=new ArrayList();
		}
		return inputFileNames;
	}
	/**
	 * @return Returns the inputFiles.
	 */
	public List getInputStreams() {
		if (inputStreams==null) {
			inputStreams = new ArrayList();
			Iterator i = inputFileNames.iterator();
			while (i.hasNext()) {
				String fileName = (String) i.next();
				try {
					FileInputStream stream = new FileInputStream(fileName);
					inputStreams.add(stream);
				} 
				catch (FileNotFoundException e) {
					System.out.println(e);
				}
			}
		}
		return inputStreams;
	}
	/**
	 * @return Returns the outputFile.
	 */
	public OutputStream getOutputStream() {
		if (outputStream==null) {
			try {
				outputStream = new FileOutputStream(outputFileName);
			} 
			catch (FileNotFoundException e) {
				System.out.println(e);
			}
		}
		return outputStream;
	}
	/**
	 * @return Returns the outputFileName.
	 */
	public String getOutputFileName() {
		return outputFileName;
	}
	/**
	 * @param outputFileName The outputFileName to set.
	 */
	public void setOutputFileName(String outputFileName) {
		this.outputFileName = outputFileName;
	}
}
