//####################################################################
//##     Copyright  Meta Integration Technology, Inc. 1997-2002    ##
//##                      All Rights Reserved.                      ##
//####################################################################
//## Meta Integration(tm) Model Bridge (MIMB), Works (MIW),         ##
//## Repository (MIR), Repository SDK (MIRSDK), and Database SDK    ##
//## (MIDBSDK) are trademarks of Meta Integration Technology, Inc.  ##
//## Other product and company names (or logos) mentioned herein    ##
//## may be the trademarks of their respective owners.              ##
//####################################################################
//##                 http://www.metaintegration.com                 ##
//####################################################################



#ifndef	MIRArrays_h
#define	MIRArrays_h 1

#include "MIRString.h"

extern MIR_STD_API int binarySearch(const unsigned char a[], int count, unsigned char key);
extern MIR_STD_API int binarySearch(const signed char a[], int count, signed char key);
extern MIR_STD_API int binarySearch(const unsigned short a[], int count, unsigned short key);
extern MIR_STD_API int binarySearch(const signed short a[], int count, signed short key);
extern MIR_STD_API int binarySearch(const unsigned int a[], int count, unsigned int key);
extern MIR_STD_API int binarySearch(const signed int a[], int count, signed int key);
extern MIR_STD_API int binarySearch(const float a[], int count, float key);
extern MIR_STD_API int binarySearch(const double a[], int count, double key);
extern MIR_STD_API int binarySearch(const char* a[], int count, const MIRTString& key);
//    These functions implement a binary search on arrays. The first 
//    parameter is the array containing the elements, count is the number 
//    of elements in the array and key is the element you are looking for. 
//    The returned value is the index of the element if found and -1 otherwise.

#endif /* end of file */
