//####################################################################
//##     Copyright  Meta Integration Technology, Inc. 1997-2002    ##
//##                      All Rights Reserved.                      ##
//####################################################################
//## Meta Integration(tm) Model Bridge (MIMB), Works (MIW),         ##
//## Repository (MIR), Repository SDK (MIRSDK), and Database SDK    ##
//## (MIDBSDK) are trademarks of Meta Integration Technology, Inc.  ##
//## Other product and company names (or logos) mentioned herein    ##
//## may be the trademarks of their respective owners.              ##
//####################################################################
//##                 http://www.metaintegration.com                 ##
//####################################################################



#ifndef MIRIO_h
#define MIRIO_h 1

#include <fstream>
#include <ios>
#include <iostream>
#include <streambuf>

#include <sys/stat.h>

#ifdef WIN32
#include <direct.h>
#endif

// From fstream
using std::filebuf;
using std::fstream;
using std::ifstream;
using std::ofstream;
using std::streampos;

// From ios
using std::ios;

// From iostream
using std::cerr;
using std::cin;
using std::cout;
using std::endl;
using std::istream;
using std::ostream;

// From streambuf
using std::streambuf;

#ifdef WIN32
#define EOL "\r\n"
#define STAT _stat
#define STAT_STRUCT _stat
#define STAT_BIT_FILE _S_IFREG
#define STAT_BIT_DIRECTORY _S_IFDIR
#define MKDIR(_PATH_) _mkdir(_PATH_)
#define putenv _putenv
#else
#define EOL "\n"
#define STAT stat
#define STAT_STRUCT stat
#define STAT_BIT_FILE S_IFREG
#define STAT_BIT_DIRECTORY S_IFDIR
#define MKDIR(_PATH_) mkdir(_PATH_,S_IRWXU)
#endif

#endif /* end of file */

