//####################################################################
//##     Copyright  Meta Integration Technology, Inc. 1997-2002    ##
//##                      All Rights Reserved.                      ##
//####################################################################
//## Meta Integration(tm) Model Bridge (MIMB), Works (MIW),         ##
//## Repository (MIR), Repository SDK (MIRSDK), and Database SDK    ##
//## (MIDBSDK) are trademarks of Meta Integration Technology, Inc.  ##
//## Other product and company names (or logos) mentioned herein    ##
//## may be the trademarks of their respective owners.              ##
//####################################################################
//##                 http://www.metaintegration.com                 ##
//####################################################################

#ifndef MIRMessage_h
#define MIRMessage_h 1

#include "MIRStdDefs.h"
#include "MIRString.h"

class MIR_STD_API MIRMessage
{
public:
    MIRMessage();
    MIRMessage(const char* msg);
    void operator=(const char* msg);
    operator const char*() const;
    operator const MIRString&() const;
    inline int getArgumentCount() {return argCount;};
private:
    int countArguments(const char* msg);
    MIRString msg;
    int argCount;
};

inline MIRMessage::operator const char*() const
{
    return msg.chars();
}

inline MIRMessage::operator const MIRString&() const
{
    return msg;
}

#endif /* end of file */
