//####################################################################
//##     Copyright  Meta Integration Technology, Inc. 1997-2003    ##
//##                      All Rights Reserved.                      ##
//####################################################################
//## Meta Integration(tm) Model Bridge (MIMB), Works (MIW),         ##
//## Repository (MIR), Repository SDK (MIRSDK), and Database SDK    ##
//## (MIDBSDK) are trademarks of Meta Integration Technology, Inc.  ##
//## Other product and company names (or logos) mentioned herein    ##
//## may be the trademarks of their respective owners.              ##
//####################################################################
//##                 http://www.metaintegration.com                 ##
//####################################################################

#ifndef MIRModelBridgeInterface_h
#define MIRModelBridgeInterface_h

#include <stdlib.h>

#if defined(WIN32)
#    ifdef __IN_MIR_MODEL_BRIDGE_INTERFACE__
#        define MIR_SPEC __declspec(dllexport)
#    else
#        define MIR_SPEC __declspec(dllimport)
#    endif
#else
#    define MIR_SPEC
#endif

#define MIR_C_API "C" MIR_SPEC

typedef void (*LOGFUNC)(const char*);

namespace MIRModelBridgeInterface {
    typedef enum return_code {
        SUCCESS=0,
        NULL_PATH,
        FAILED_TO_LOAD_DLL,
        SETCONFDIRECTORY_NOT_FOUND,
        REQUEST_NOT_FOUND,
        TOCHARS_NOT_FOUND,
        RELEASE_NOT_FOUND,
        SETCALLERID_NOT_FOUND
    };

    extern MIR_C_API return_code setBinDirectory(const char* path);
    extern MIR_C_API       void  setConfDirectory(const char* path);
    extern MIR_C_API       void  setCallerId(const char* id);
    extern MIR_C_API const void* request(const char* request, LOGFUNC logFunc=NULL);
    extern MIR_C_API const char* toChars(const void* reply);
    extern MIR_C_API       void  release(const void* reply);
};

#endif
