//####################################################################
//##     Copyright  Meta Integration Technology, Inc. 1997-2002    ##
//##                      All Rights Reserved.                      ##
//####################################################################
//## Meta Integration(tm) Model Bridge (MIMB), Works (MIW),         ##
//## Repository (MIR), Repository SDK (MIRSDK), and Database SDK    ##
//## (MIDBSDK) are trademarks of Meta Integration Technology, Inc.  ##
//## Other product and company names (or logos) mentioned herein    ##
//## may be the trademarks of their respective owners.              ##
//####################################################################
//##                 http://www.metaintegration.com                 ##
//####################################################################


#ifndef MIRStdDefs_h
#define MIRStdDefs_h 1

#if defined(WIN32) && !defined(__MIR_STD_STATIC__)
#    ifdef __IN_MIR_STD__
#        define MIR_STD_API __declspec(dllexport)
#    else
#        define MIR_STD_API __declspec(dllimport)
#    endif /* __IN_MIR_STD__ */
#else
#    define MIR_STD_API
#endif /* WIN32 && !__MIR_STD_STATIC__ */

#define MIR_STD_CAPI "C" MIR_STD_API


#ifdef WIN32
#    ifdef _DEBUG
#        include <crtdbg.h>
#        define _new_dbg new(_NORMAL_BLOCK,__FILE__,__LINE__)
#    else
#        define _new_dbg new
#        ifndef _NORMAL_BLOCK
#            define _NORMAL_BLOCK 0
#        endif
#        ifndef _malloc_dbg
#            define _malloc_dbg(size,block_type,file,line) malloc(size)
#        endif
#    endif
#else  /* !WIN32 */
#    define _NORMAL_BLOCK 0
#    define _new_dbg new
#    define _malloc_dbg(size,block_type,file,line) malloc(size)
#endif /* WIN32 */

#if defined(MPRAS)
//XERCES defines bool in its own include files, do not redefine them here
#  ifndef NO_NATIVE_BOOL
#    ifndef bool
typedef unsigned short int bool;
#        define true    ((bool)1)
#        define false   ((bool)0)
#    endif
#  endif
#endif

#ifdef __GNUC__
#    define MIR_UNUSED __attribute__((unused))
#else
#    define MIR_UNUSED
#endif

typedef bool MIRBoolean;


#endif /* end of file */
