//####################################################################
//##     Copyright  Meta Integration Technology, Inc. 1997-2002    ##
//##                      All Rights Reserved.                      ##
//####################################################################
//## Meta Integration(tm) Model Bridge (MIMB), Works (MIW),         ##
//## Repository (MIR), Repository SDK (MIRSDK), and Database SDK    ##
//## (MIDBSDK) are trademarks of Meta Integration Technology, Inc.  ##
//## Other product and company names (or logos) mentioned herein    ##
//## may be the trademarks of their respective owners.              ##
//####################################################################
//##                 http://www.metaintegration.com                 ##
//####################################################################



#ifndef MIRStringHashtable_h
#define MIRStringHashtable_h 1

#include "MIRString.h"
#include "MIRHashtable.h"

class MIR_STD_API MIRStringHashtable: public MIRHashtable
{
  public:

    //## Construction and destruction

      MIRStringHashtable(int size);
      ~MIRStringHashtable();

      typedef MIRHashtable::Iterator Iterator;

  protected:

    //## Methods we have to extend to make the hashtable functional

      int compare2Object(const MIRContainerItem* ptr1, const MIRContainerItem* ptr2) const;
      virtual int compare2Key(const MIRContainerItem* ptr, const MIRContainerKey* key) const;
      virtual unsigned int hashObject(const MIRContainerItem* ptr) const;
      virtual unsigned int hashKey(const MIRContainerKey* key) const;
};

typedef MIRStringHashtable::Iterator MIRStringHashtableIterator;

/*
 * Inline operations
 */
inline MIRStringHashtable::MIRStringHashtable(int _size):
    MIRHashtable(_size)
{
}

inline MIRStringHashtable::~MIRStringHashtable()
{
}

inline int MIRStringHashtable::compare2Object(const MIRContainerItem* ptr1, const MIRContainerItem* ptr2) const
{
    return ((MIRString*)ptr1)->compare(*(MIRString*)ptr2);
}

inline int MIRStringHashtable::compare2Key(const MIRContainerItem* ptr, const MIRContainerKey* key) const
{
    return ((MIRString*)ptr)->compare((const char*)key);
}

inline unsigned int MIRStringHashtable::hashObject(const MIRContainerItem* ptr) const
{
    return ((MIRString*)ptr)->hashCode();
}

inline unsigned int MIRStringHashtable::hashKey(const MIRContainerKey* key) const
{
    return stringHashCode((const char*)key);
}

#endif /* end of file */
