//####################################################################
//##     Copyright  Meta Integration Technology, Inc. 1997-2003    ##
//##                      All Rights Reserved.                      ##
//####################################################################
//## Meta Integration(tm) Model Bridge (MIMB), Works (MIW),         ##
//## Repository (MIR), Repository SDK (MIRSDK), and Database SDK    ##
//## (MIDBSDK) are trademarks of Meta Integration Technology, Inc.  ##
//## Other product and company names (or logos) mentioned herein    ##
//## may be the trademarks of their respective owners.              ##
//####################################################################
//##                 http://www.metaintegration.com                 ##
//####################################################################

#ifndef MIRXmlInterface_h
#define MIRXmlInterface_h

#if defined(WIN32)
#    ifdef __IN_MIR_MODEL_BRIDGE__
#        define MIR_MODEL_BRIDGE_EXPORT __declspec(dllexport)
#    else
#        define MIR_MODEL_BRIDGE_EXPORT __declspec(dllimport)
#    endif /* __IN_MIR_MODEL_BRIDGE__ */
#else
#    define MIR_MODEL_BRIDGE_EXPORT
#endif /* WIN32 */

#define MIR_MODEL_BRIDGE_CAPI "C" MIR_MODEL_BRIDGE_EXPORT

typedef void (*LOGFUNC)(const char*);

namespace MIRModelBridgeXml {
    extern MIR_MODEL_BRIDGE_CAPI       void  setConfDirectory(const char* path);
    extern MIR_MODEL_BRIDGE_CAPI       void  setCallerId(const char* id);
    extern MIR_MODEL_BRIDGE_CAPI const void* request(const char* request, LOGFUNC logFunc=NULL);
    extern MIR_MODEL_BRIDGE_CAPI const char* toChars(const void* reply);
    extern MIR_MODEL_BRIDGE_CAPI       void  release(const void* reply);
};

#endif
